package com.oracle.coherence.handson;

import com.tangosol.net.CacheFactory;
import com.tangosol.net.CacheService;
import com.tangosol.net.Cluster;
import com.tangosol.net.Member;
import com.tangosol.net.NamedCache;

import java.util.Iterator;


public class CacheInfo {
    public CacheInfo() {
    }

    public static void main(String[] args) {
         
        // create or get a named cache called mycache 
        NamedCache myCache = CacheFactory.getCache("mycache");
       
        // get the information about the cluster and local member
        Cluster cluster    = CacheFactory.getCluster();
        Member  memberThis = cluster.getLocalMember();
        
        System.out.println("Local member info: " + memberThis);
        
        // list all the members - highlighting the curret one
        for (Iterator iter = cluster.getMemberSet().iterator(); iter.hasNext(); )  {
            Member member = (Member) iter.next();
            
            System.out.println(member + 
                (member.equals(memberThis) ? " <-- this node" : ""));
        }
        
        
    }
}
