package com.oracle.coherence.handson;

import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;
import com.tangosol.util.Filter;
import com.tangosol.util.aggregator.DoubleAverage;
import com.tangosol.util.aggregator.DoubleMax;
import com.tangosol.util.filter.AlwaysFilter;
import com.tangosol.util.filter.EqualsFilter;

import java.math.BigDecimal;

public class AggregationExample {
    public AggregationExample() {
    }

    public static void main(String[] args) {
        Double averageAgeMales = null;
        Double averageAgeFemales = null;
        Double maxAge = null;
        Double averageAge = null;
        int max = 100;
        
        NamedCache person = CacheFactory.getCache("person");
        long totalTime = 0;
        
        // create a new query 
        
        for (int i = 0; i< max; i++) {
          long startTime = System.currentTimeMillis();

          averageAgeMales = (Double)person.aggregate( 
                          new EqualsFilter("getGender",Person.MALE ),
                          new DoubleAverage("getAgeDouble")
                          );
                
          averageAgeFemales = (Double)person.aggregate( 
                          new EqualsFilter("getGender",Person.FEMALE ),
                          new DoubleAverage("getAgeDouble")
                          );
        
          maxAge = (Double)person.aggregate( 
                          (Filter)null,   // new AlwaysFilter()
                          new DoubleMax("getAgeDouble")
                          );
        
          averageAge = (Double)person.aggregate( 
                          new EqualsFilter("getGender",Person.FEMALE ),
                          new DoubleAverage("getAgeDouble")
                          );
        
        
          long endTime = System.currentTimeMillis();
        
          System.out.println("Total time taken is " + (endTime - startTime) / 1000F + " seconds");
          totalTime += (endTime - startTime);
        }            
        
        System.out.println("Average time is " +  (totalTime / max) / 1000F);
        
        //System.out.println("Average age of males is " + averageAgeMales);
        //System.out.println("Average age of femals is " + averageAgeFemales);
        //System.out.println("Max age is " + maxAge);
        //System.out.println("Average age  " + averageAge); 
    }
}
