package com.oracle.coherence.handson;

import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;
import com.tangosol.util.MapEvent;
import com.tangosol.util.MapListener;
import com.tangosol.util.filter.EqualsFilter;
import com.tangosol.util.filter.MapEventFilter;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class ListenForNewPerson {
    public ListenForNewPerson() {
    }

    public static void main(String[] args) throws IOException {
        // connect to named cache
        NamedCache person = CacheFactory.getCache("person");
        
        // listen for insert events on Person
        // This can be done in an easier way by using a new AbstractMapListener()
        // and then overriding only the method you want to
        //
        person.addMapListener(new MapListener()
        {
          public void entryDeleted(MapEvent mapEvent) {
            // ignore
          }
          public void entryInserted(MapEvent mapEvent) {
             Person p = (Person)mapEvent.getNewValue();
             System.out.println("New person added: " + p.getFirstname() + " " + p.getSurname());
          }
          public void entryUpdated(MapEvent mapEvent) {
             // ignore 
          }
        }
        );
        
        
        System.out.println("waiting for events");
        BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
        String text = console.readLine();
        
    }
}
